diff --git a/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
index 35c3d21ca..6a0e2d5ce 100644
--- a/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
@@ -40,4 +40,9 @@ public class RedstonePumpkinBlock extends RotatableBlock {
         Side mySide = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
         return mySide == side.getOpposite();
     }
+
+    @Override
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        return Material.PISTON_PUSHABLE;
+    }
 }
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 53c601d8c..7ad832bdf 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -494,7 +494,7 @@ public class MinecraftServer
 
     }
 
-    private void stopServer()
+    public void stopServer()
     {
         LOGGER.info("Stopping server");
         if (statsStatus)
diff --git a/src/main/java/net/minecraft/server/gui/ServerGui.java b/src/main/java/net/minecraft/server/gui/ServerGui.java
index bc4a987eb..9f2d1b9f9 100644
--- a/src/main/java/net/minecraft/server/gui/ServerGui.java
+++ b/src/main/java/net/minecraft/server/gui/ServerGui.java
@@ -51,6 +51,7 @@ public class ServerGui extends JComponent
         jframe.addWindowListener(new WindowAdapter() {
             @Override
             public void windowClosing(WindowEvent e) {
+                mcServer.stopServer();
                 mcServer.initiateShutdown();
                 while(!mcServer.serverStopped)
                 {
